//#########################################################
//INSERIRE: COGNOME - NOME - NUMERO POSTAZIONE - PROFESSORE
//#########################################################
//NON MODIFICARE il codice delle classi e dei metodi forniti
//NON AGGIUNGERE NUOVO CODICE al di fuori di quello richiesto

//PER COMPILARE USARE IL COMANDO:  "javac risultato.java"
//PER ESEGUIRE  USARE IL COMANDO:  "java Main"

class Graph  {
    
  private int[][] mat ;  
  private int nvert; 
  
  public Graph(int nv ) { 
    mat = new int[nv+1][nv+1];
    nvert = nv;
    for (int i=1; i <= nvert; i++) 
       for (int j=1; j <= nvert; j++)
          mat[i][j] = 0;
  } 
  
  public void insArc( int i, int j, int w ) {
     mat[i][j] = w;
     mat[j][i] = w;
     return; 
  } 

  public int[] dijkstra( int s ) {
    
    final int inf = Integer.MAX_VALUE;
    int pre[] = new int[nvert+1];
    VertexPQ pq = new MyVertexPQ(nvert);
    
    for (int i = 1; i <= nvert; i++) {
       pq.insert(i,inf);
       pre[i] = i;
    }
         
    pq.update(s,0);
   
    while( ! pq.isEmpty() ) {
        pq.print();
        int u = pq.extractMin();
        System.out.println("\nmin = " + u);
        int v;  // se esiste un vertice adiacente non ancora visitato
        for ( v = 1; v <= nvert; v++ ) {
           int w =  mat[u][v];
           if (w != 0 &&  pq.isIn(v) )
             if ( pq.dis(v) >  pq.dis(u) + w )  {
                pq.update(v, pq.dis(u) + w);
                pre[v] = u;
             }
        }     
    }

    return pre;    
  } 

}//class Graph


class Main  {   

  static void printPred(int[] p, int ne ) {
    System.out.print("\nVet predecessori ->");
    for ( int i = 1; i <= ne; i++ )
      System.out.print(" " + p[i]);
  }  
  
  public static void main( String argv[] ) throws Exception { 
    int nvert = 6;
    int[] pre;
    //GRAFO NON ORIENTATO
    Graph G = new Graph(nvert);
    G.insArc(1,2,2);
    G.insArc(1,3,8);
    G.insArc(1,5,7);
    G.insArc(2,3,5);
    G.insArc(2,4,7);
    G.insArc(3,4,9);
    G.insArc(4,6,4);
    G.insArc(5,3,8);
    G.insArc(5,6,3);
    pre = G.dijkstra(1);
    System.out.print("\nDijkstra:");
    printPred(pre,nvert);
    System.out.println();
  }
  
}//class